#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct point
{
    double x, y;
    point() {}
    point(double a, double b)
    {
        x=a;
        y=b;
    }
};

struct segm
{
    double x1, y1, x2, y2;
    segm() {}
    segm(double a, double b, double c, double d)
    {
        x1=a;
        y1=b;
        x2=c;
        y2=d;
    }
    void correct()
    {
        if(x1>x2 || (x1==x2 && y1>y2))
        {
            swap(x1, x2);
            swap(y1, y2);
        }
    }
};

bool pres(segm s1, segm s2)
{
    bool s1vert=0, s1hor=0, s2vert=0, s2hor=0;
    if(s1.x1==s1.x2) s1vert=1;
    if(s1.y1==s1.y2) s1hor=1;
    if(s2.x1==s2.x2) s2vert=1;
    if(s2.y1==s2.y2) s2hor=1;
    if(s1vert && s2vert)
    {
        if(s1.x1!=s2.x1) return 0;
        if(s1.y2<s2.y1 || s1.y1>s2.y2) return 0;
        return 1;
    }
    if(s1hor && s2hor)
    {
        if(s1.y1!=s2.y1) return 0;
        if(s1.x2<s2.x1 || s1.x1>s2.x2) return 0;
        return 1;
    }
    if(s2hor || s2vert)
    {
        swap(s1, s2);
        swap(s1vert, s2vert);
        swap(s1hor, s2hor);
    }
    if(s1vert)
    {
        if((s2.x1-s1.x1)*(s2.x2-s1.x1)>0) return 0;
        double y=s2.y2-(s2.x2-s1.x1)*(s2.y2-s2.y1)/(s2.x2-s2.x1);
        if(s1.y1<=y && y<=s1.y2 && floor(y)==y) return 1;
        else return 0;
    }
    if(s1hor)
    {
        if((s2.y1-s1.y1)*(s2.y2-s1.y1)>0) return 0;
        double x=s2.x2-(s2.y2-s1.y1)*(s2.x2-s2.x1)/(s2.y2-s2.y1);
        if(s1.x1<=x && x<=s1.x2 && floor(x)==x) return 1;
        else return 0;
    }
    double k1=(double)(s1.y2-s1.y1)/(s1.x2-s1.x1), k2=(double)(s2.y2-s2.y1)/(s2.x2-s2.x1);
    double n1=(double) s1.x2-s1.y2*(s1.x2-s1.x1)/(s1.y2-s1.y1), n2=(double) s2.x2-s2.y2*(s2.x2-s2.x1)/(s2.y2-s2.y1);
    if(k1==k2 && n1==n2)
    {
        if(s1.x1>s2.x2 || s2.x1>s1.x2) return 0;
        return 1;
    }
    else if(k1==k2 && n1!=n2) return 0;
    double x=(n1-n2)/(k2-k1), y=k1*x+n1;
    if(x!=floor(x) && y!=floor(y)) return 0;
    if(s1.x1>x || s1.x2<x) return 0;
    if(s2.x1>x || s2.x2<x) return 0;
    return 1;
}

segm ots[105];

vector<int> gr[105];
int ma=1, tekma;
bool used[105];

void dfs(int vr)
{
    ma=max(ma, tekma);
    for(int i=0; i<gr[vr].size(); i++)
    {
        if(!used[gr[vr][i]])
        {
            used[gr[vr][i]]=1;
            tekma++;
            dfs(gr[vr][i]);
            used[gr[vr][i]]=0;
            tekma--;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    for(int i=1; i<=n; i++)
    {
        double tx1, tx2, ty1, ty2;
        cin>>tx1>>ty1>>tx2>>ty2;
        ots[i]=segm(tx1+300, ty1+300, tx2+300, ty2+300);
        ots[i].correct();
    }
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            if(pres(ots[i], ots[j])) gr[i].push_back(j);
        }
    }
    for(int i=1; i<=1; i++)
    {
        tekma=1;
        used[i]=1;
        dfs(i);
        used[i]=0;
    }
    cout<<ma<<endl;
    return 0;
}

