#include<iostream>
#include<algorithm>
#include<vector>

#define endl '\n'

using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin>>n;
    vector<int> nums,digits[n+3];
    for(int i=1;i<=n;++i){
        nums.push_back(i);
        int curr=i;
        while(curr>0){
            digits[i].push_back(curr%10);
            curr/=10;
        }
        reverse(digits[i].begin(),digits[i].end());
    }

    int res=0;
    do{
        int diff=0;
        bool type=false;
        for(int num : nums){
            for(int curr : digits[num]){
                if(type){
                    diff-=curr;
                }else{
                    diff+=curr;
                }
                type=!type;
            }
        }
        res+=(diff%11==0);
    }while(next_permutation(nums.begin(),nums.end()));
    cout<<res<<endl;
return 0;
}
