#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e2+10;
const int MAXX=5e2+10;
vector <int> v[MAXN];
vector <int> p[MAXX][MAXX];
int x1[MAXN], y1[MAXN], x2[MAXN], y2[MAXN];
int dp[MAXN][MAXN];
bool con[MAXN][MAXN], used[MAXN];
int maxx, maxy, minx, miny;
int NOD(int a, int b) {
    int r;
    while (b>0) {
        r=a%b;
        a=b;
        b=r;
    }
    return a;
}
void points(int chx, int chy, int ind) {
    int x, y;
    x=x1[ind]; y=y1[ind];
    while (x!=x2[ind] || y!=y2[ind]) {
        p[x+250][y+250].push_back(ind);
        x+=chx; y+=chy;
    }
    p[x+250][y+250].push_back(ind);
}
void connect(int x, int y) {
    for (auto i:p[x][y]) {
        for (auto j:p[x][y]) {
            if (con[i][j]) continue;
            v[i].push_back(j);
            dp[i][j]=dp[j][i]=1;
            con[i][j]=true;
        }
    }
}
int dfs(int x) {
    used[x]=true;
    int p=0;
    for (auto i:v[x]) {
        if (used[i]) continue;
        p=max(p,dfs(i)+1);
        used[i]=false;
    }
    return p;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    maxx=maxy=-300;
    minx=miny=300;
    for (int i=0;i<n;i++) {
        cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
        maxx=max(maxx,max(x1[i],x2[i]));
        maxy=max(maxy,max(y1[i],y2[i]));
        minx=min(minx,min(x1[i],x2[i]));
        miny=min(miny,min(y1[i],y2[i]));
        con[i][i]=true;
    }
    int chx, chy, d;
    bool px, py;
    for (int i=0;i<n;i++) {
        chx=x1[i]-x2[i];
        if (chx<0) {
            chx=-chx;
            px=true;
        } else px=false;
        chy=y1[i]-y2[i];
        if (chy<0) {
            chy=-chy;
            py=true;
        } else py=false;
        if (chx==0 || chy==0) d=max(chx,chy);
        else d=NOD(chx,chy);
        chx/=d; chy/=d;
        if (!px) chx=-chx;
        if (!py) chy=-chy;
        points(chx,chy,i);
    }
    for (int xi=minx;xi<=maxx;xi++) {
        for (int yi=miny;yi<=maxy;yi++) {
            connect(xi+250,yi+250);
        }
    }
    int ans=0;
    for (int i=0;i<n;i++) {
        ans=max(ans,dfs(i));
        used[i]=false;
    }
    cout << ans+1 << endl;
    return 0;
}
/**
7
0 2 2 4
0 3 5 3
2 2 5 2
3 1 3 4
4 1 4 4
5 2 2 2
2 0 3 5
**/
