#include <bits/stdc++.h>
using namespace std;

struct Seg{
    int x1;
    int y1;
    int x2;
    int y2;
};

Seg a[100];

int neigh[101][101];

int same(int a, int b){
    if(a == 0) return b == 0;
    return a*b > 0;
}

int check(Seg s, int qx, int qy){
    int x1 = s.x1, y1 = s.y1, x2 = s.x2, y2 = s.y2;
    int vx = x2 - x1;
    int vy = y2 - y1;
    int qvx = qx - x1;
    int qvy = qy - y1;
    //printf("%d %d %d %d", vx, vy, qvx, qvy);
    if (same(vx, qvx) && same(vy, qvy)/* abs(qvx) < abs(vx) && abs(qvy) < abs(vy) &&*/)
        if (vx * qvy == vy * qvx)
            if( abs(qvx) <= abs(vx) && abs(qvy) <= abs(vy)){
                //printf("%d %d %d %d -> %d %d\n", x1, y1, x2, y2, qx, qy);
                return 1;
        }
    return 0;
}

int main(){
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d%d%d%d", &a[i].x1, &a[i].y1, &a[i].x2, &a[i].y2);
    for (int i = 0; i < n; i++) {
        //fprintf(stderr, "%d\n", i);
        int x1 = a[i].x1, y1 = a[i].y1, x2 = a[i].x2, y2 = a[i].y2;
        int vx = x2 - x1;
        int vy = y2 - y1;
        int g = __gcd(abs(vx), abs(vy));
        for (int k = 0; k <= g; k++) {
            int cx = ((vx * k) / g) + x1;
            int cy = ((vy * k) / g) + y1;
            //printf("%d %d %d %d -> %d %d\n", x1, y1, x2, y2, cx, cy);
            for (int j = 0; j < n ; j++)
                if (check(a[j], cx, cy)) {
                    neigh[i][j] = 1;
                }
        }
    }
    int perm[101];
    for(int i = 0; i < n; i++)
        perm[i] = i;
    int ans = 0;
    do{
        int l = 1;
        for(int i = 0; i < n; i++){
            if(neigh[perm[i]][perm[(i+1)%n]]) l++;
            else break;
        }
        ans = max(ans, l);
    }while(next_permutation(perm, perm+n));
    printf("%d", ans);
}
/**
7
0 2 2 4
0 3 5 3
2 2 5 2
3 1 3 4
4 1 4 4
5 2 2 2
2 0 3 5
**/
