#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
const int MAXN = 110, add = 250;

vector < int > v[510][510];
vector < int > g[MAXN];
int n, p[MAXN][MAXN], used[MAXN], u[MAXN];

void dfs(int s, int cnt = 1)
{
    int sz = g[s].size();
    for (int j = 0; j < sz; j ++)
    {
        int to = g[s][j];
        if (!used[to] || (used[to] < used[s] && u[to] != u[s]))
        {
            used[to] = used[s] + 1;
            u[to] = u[s];
            dfs(to, cnt);
            cnt ++;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int d1 = abs(x1 - x2), d2 = abs(y1 - y2);
        int nod = __gcd(d1, d2);
        d1 /= nod;
        d2 /= nod;
        if (x1 > x2)
            d1 = -d1;
        if (y1 > y2)
            d2 = -d2;

        while(true)
        {
            int sz = v[x1 + add][y1 + add].size();
            for (int j = 0; j < sz; j ++)
            {
                int ver = v[x1 + add][y1 + add][j];
                if (p[i][ver] != 1)
                {
                    g[i].push_back(ver);
                    g[ver].push_back(i);
                    p[i][ver] = p[ver][i] = 1;
                }
            }
            v[x1 + add][y1 + add].push_back(i);
            if (x1 == x2 && y1 == y2)
                break;
            x1 += d1;
            y1 += d2;
        }
    }

    int ans = 0;
    for (int i = 1; i <= n; i ++)
    {
        memset(used, 0, sizeof(used));
        used[i] = 1;
        u[i] = 1;
        dfs(i);
        for (int j = 1; j <= n; j ++)
            if (used[j] > ans)
            ans = used[j];
    }
    cout << ans << endl;
    return 0;
}
/**
7
0 2 2 4
0 3 5 3
2 2 5 2
3 1 3 4
4 1 4 4
5 2 2 2
2 0 3 5
*/
